/*
  OPVPWrapper.cc
*/


#include "OPVPWrapper.h"

OPVPWrapper::OPVPWrapper(OPVP_api_procs *procsA)
{
    procs = procsA;
}

OPVPWrapper::~OPVPWrapper()
{
}

int OPVPWrapper::ClosePrinter(int printerContext)
{
    if (procs->ClosePrinter == 0) return -1;
    return procs->ClosePrinter(printerContext);
}

int OPVPWrapper::StartJob(int printerContext, char *jobInfo)
{
    if (procs->StartJob == 0) return -1;
    return procs->StartJob(printerContext,jobInfo);
}

int OPVPWrapper::EndJob(int printerContext)
{
    if (procs->EndJob == 0) return -1;
    return procs->EndJob(printerContext);
}

int OPVPWrapper::StartDoc(int printerContext, char *docInfo)
{
    if (procs->StartDoc == 0) return -1;
    return procs->StartDoc(printerContext,docInfo);
}

int OPVPWrapper::EndDoc(int printerContext)
{
    if (procs->EndDoc == 0) return -1;
    return procs->EndDoc(printerContext);
}

int OPVPWrapper::StartPage(int printerContext, char *pageInfo)
{
    if (procs->StartPage == 0) return -1;
    return procs->StartPage(printerContext,pageInfo);
}

int OPVPWrapper::EndPage(int printerContext)
{
    if (procs->EndPage == 0) return -1;
    return procs->EndPage(printerContext);
}

int OPVPWrapper::ResetCTM(int printerContext)
{
    if (procs->ResetCTM == 0) return -1;
    return procs->ResetCTM(printerContext);
}

int OPVPWrapper::SetCTM(int printerContext, OPVP_CTM *pCTM)
{
    if (procs->SetCTM == 0) return -1;
    return procs->SetCTM(printerContext,pCTM);
}

int OPVPWrapper::GetCTM(int printerContext, OPVP_CTM *pCTM)
{
    if (procs->GetCTM == 0) return -1;
    return procs->GetCTM(printerContext,pCTM);
}

int OPVPWrapper::InitGS(int printerContext)
{
    if (procs->InitGS == 0) return -1;
    return procs->InitGS(printerContext);
}

int OPVPWrapper::SaveGS(int printerContext)
{
    if (procs->SaveGS == 0) return -1;
    return procs->SaveGS(printerContext);
}

int OPVPWrapper::RestoreGS(int printerContext)
{
    if (procs->RestoreGS == 0) return -1;
    return procs->RestoreGS(printerContext);
}

int OPVPWrapper::QueryColorSpace(int printerContext, OPVP_ColorSpace *pcspace,
    int *pnum)
{
    if (procs->QueryColorSpace == 0) return -1;
    return procs->QueryColorSpace(printerContext,pcspace,pnum);
}

int OPVPWrapper::SetColorSpace(int printerContext, OPVP_ColorSpace cspace)
{
    if (procs->SetColorSpace == 0) return -1;
    return procs->SetColorSpace(printerContext,cspace);
}

int OPVPWrapper::GetColorSpace(int printerContext, OPVP_ColorSpace *pcspace)
{
    if (procs->GetColorSpace == 0) return -1;
    return procs->GetColorSpace(printerContext,pcspace);
}

int OPVPWrapper::QueryROP(int printerContext, int *pnum, int *prop)
{
    if (procs->QueryROP == 0) return -1;
    return procs->QueryROP(printerContext,pnum,prop);
}

int OPVPWrapper::SetROP(int printerContext, int rop)
{
    if (procs->SetROP == 0) return -1;
    return procs->SetROP(printerContext,rop);
}

int OPVPWrapper::GetROP(int printerContext, int *prop)
{
    if (procs->GetROP == 0) return -1;
    return procs->GetROP(printerContext,prop);
}

int OPVPWrapper::SetFillMode(int printerContext, OPVP_FillMode fillmode)
{
    if (procs->SetFillMode == 0) return -1;
    return procs->SetFillMode(printerContext,fillmode);
}

int OPVPWrapper::GetFillMode(int printerContext, OPVP_FillMode *pfillmode)
{
    if (procs->GetFillMode == 0) return -1;
    return procs->GetFillMode(printerContext,pfillmode);
}

int OPVPWrapper::SetAlphaConstant(int printerContext, float alpha)
{
    if (procs->SetAlphaConstant == 0) return -1;
    return procs->SetAlphaConstant(printerContext,alpha);
}

int OPVPWrapper::GetAlphaConstant(int printerContext, float *palpha)
{
    if (procs->GetAlphaConstant == 0) return -1;
    return procs->GetAlphaConstant(printerContext,palpha);
}

int OPVPWrapper::SetLineWidth(int printerContext, OPVP_Fix width)
{
    if (procs->SetLineWidth == 0) return -1;
    return procs->SetLineWidth(printerContext,width);
}

int OPVPWrapper::GetLineWidth(int printerContext, OPVP_Fix *pwidth)
{
    if (procs->GetLineWidth == 0) return -1;
    return procs->GetLineWidth(printerContext,pwidth);
}

int OPVPWrapper::SetLineDash(int printerContext, OPVP_Fix pdash[], int num)
{
    if (procs->SetLineDash == 0) return 0; /* for HP */
    return procs->SetLineDash(printerContext,pdash,num);
}

int OPVPWrapper::GetLineDash(int printerContext, OPVP_Fix pdash[], int *pnum)
{
    if (procs->GetLineDash == 0) return -1;
    return procs->GetLineDash(printerContext,pdash,pnum);
}

int OPVPWrapper::SetLineDashOffset(int printerContext, OPVP_Fix offset)
{
    if (procs->SetLineDashOffset == 0) return 0; /* for HP */
    return procs->SetLineDashOffset(printerContext,offset);
}

int OPVPWrapper::GetLineDashOffset(int printerContext, OPVP_Fix *poffset)
{
    if (procs->GetLineDashOffset == 0) return -1;
    return procs->GetLineDashOffset(printerContext,poffset);
}

int OPVPWrapper::SetLineStyle(int printerContext, OPVP_LineStyle linestyle)
{
    if (procs->SetLineStyle == 0) return 0; /* for HP */
    return procs->SetLineStyle(printerContext,linestyle);
}

int OPVPWrapper::GetLineStyle(int printerContext, OPVP_LineStyle *plinestyle)
{
    if (procs->GetLineStyle == 0) return -1;
    return procs->GetLineStyle(printerContext,plinestyle);
}

int OPVPWrapper::SetLineCap(int printerContext, OPVP_LineCap linecap)
{
    if (procs->SetLineCap == 0) return -1;
    return procs->SetLineCap(printerContext,linecap);
}

int OPVPWrapper::GetLineCap(int printerContext, OPVP_LineCap *plinecap)
{
    if (procs->GetLineCap == 0) return -1;
    return procs->GetLineCap(printerContext,plinecap);
}

int OPVPWrapper::SetLineJoin(int printerContext, OPVP_LineJoin linejoin)
{
    if (procs->SetLineJoin == 0) return -1;
    return procs->SetLineJoin(printerContext,linejoin);
}

int OPVPWrapper::GetLineJoin(int printerContext, OPVP_LineJoin *plinejoin)
{
    if (procs->GetLineJoin == 0) return -1;
    return procs->GetLineJoin(printerContext,plinejoin);
}

int OPVPWrapper::SetMiterLimit(int printerContext, OPVP_Fix miterlimit)
{
    if (procs->SetMiterLimit == 0) return -1;
    return procs->SetMiterLimit(printerContext,miterlimit);
}

int OPVPWrapper::GetMiterLimit(int printerContext, OPVP_Fix *pmiterlimit)
{
    if (procs->GetMiterLimit == 0) return -1;
    return procs->GetMiterLimit(printerContext,pmiterlimit);
}

int OPVPWrapper::SetPaintMode(int printerContext, OPVP_PaintMode paintmode)
{
    if (procs->SetPaintMode == 0) return -1;
    return procs->SetPaintMode(printerContext,paintmode);
}

int OPVPWrapper::GetPaintMode(int printerContext, OPVP_PaintMode *ppaintmode)
{
    if (procs->GetPaintMode == 0) return -1;
    return procs->GetPaintMode(printerContext,ppaintmode);
}

int OPVPWrapper::SetStrokeColor(int printerContext, OPVP_Brush *brush)
{
    if (procs->SetStrokeColor == 0) return -1;
    return procs->SetStrokeColor(printerContext,brush);
}

int OPVPWrapper::SetFillColor(int printerContext, OPVP_Brush *brush)
{
    if (procs->SetFillColor == 0) return -1;
    return procs->SetFillColor(printerContext,brush);
}

int OPVPWrapper::SetBgColor(int printerContext, OPVP_Brush *brush)
{
    if (procs->SetBgColor == 0) return -1;
    return procs->SetBgColor(printerContext,brush);
}

int OPVPWrapper::NewPath(int printerContext)
{
    if (procs->NewPath == 0) return -1;
    return procs->NewPath(printerContext);
}

int OPVPWrapper::EndPath(int printerContext)
{
    if (procs->EndPath == 0) return -1;
    return procs->EndPath(printerContext);
}

int OPVPWrapper::StrokePath(int printerContext)
{
    if (procs->StrokePath == 0) return -1;
    return procs->StrokePath(printerContext);
}

int OPVPWrapper::FillPath(int printerContext)
{
    if (procs->FillPath == 0) return -1;
    return procs->FillPath(printerContext);
}

int OPVPWrapper::StrokeFillPath(int printerContext)
{
    if (procs->StrokeFillPath == 0) return -1;
    return procs->StrokeFillPath(printerContext);
}

int OPVPWrapper::SetClipPath(int printerContext, OPVP_ClipRule clipRule)
{
    //if (procs->SetClipPath == 0) return -1;
    if (procs->SetClipPath == 0) return 0;/* for HP */
    return procs->SetClipPath(printerContext,clipRule);
}

int OPVPWrapper::SetCurrentPoint(int printerContext, OPVP_Fix x, OPVP_Fix y)
{
    if (procs->SetCurrentPoint == 0) return -1;
    return procs->SetCurrentPoint(printerContext,x,y);
}

int OPVPWrapper::LinePath(int printerContext, int flag, int npoints,
    OPVP_Point *points)
{
    if (procs->LinePath == 0) return -1;
    return procs->LinePath(printerContext,flag,npoints,points);
}

int OPVPWrapper::PolygonPath(int printerContext, int npolygons, int *nvertexes,
    OPVP_Point *points)
{
    if (procs->PolygonPath == 0) return -1;
    return procs->PolygonPath(printerContext,npolygons,nvertexes,points);
}

int OPVPWrapper::RectanglePath(int printerContext, int nrectangles,
    OPVP_Rectangle *rectangles)
{
    if (procs->RectanglePath == 0) return -1;
    return procs->RectanglePath(printerContext,nrectangles,rectangles);
}

int OPVPWrapper::RoundRectanglePath(int printerContext, int nrectangles,
    OPVP_RoundRectangle *rectangles)
{
    if (procs->RoundRectanglePath == 0) return -1;
    return procs->RoundRectanglePath(printerContext,nrectangles,rectangles);
}

#if (_PDAPI_VERSION_MAJOR_ == 0 && _PDAPI_VERSION_MINOR_ < 2)
int OPVPWrapper::BezierPath(int printerContext, int *npoints,
    OPVP_Point *points)
{
    if (procs->BezierPath == 0) return -1;
    return procs->BezierPath(printerContext,npoints,points);
}

#else
int OPVPWrapper::BezierPath(int printerContext, int npoints,
    OPVP_Point *points)
{
    if (procs->BezierPath == 0) return -1;
    return procs->BezierPath(printerContext,npoints,points);
}

#endif
int OPVPWrapper::ArcPath(int printerContext, int kind, int dir, OPVP_Fix bbx0,
    OPVP_Fix bby0, OPVP_Fix bbx1, OPVP_Fix bby1, OPVP_Fix x0,
    OPVP_Fix y0, OPVP_Fix x1, OPVP_Fix y1)
{
    if (procs->ArcPath == 0) return -1;
    return procs->ArcPath(printerContext,kind,dir,bbx0,bby0,
       bbx1,bby1,x0,y0,x1,y1);
}

int OPVPWrapper::DrawBitmapText(int printerContext, int width, int height,
    int pitch, void *fontdata)
{
    if (procs->DrawBitmapText == 0) return -1;
    return procs->DrawBitmapText(printerContext,width,height,
      pitch, fontdata);
}

int OPVPWrapper::DrawImage(int printerContext, int sourceWidth,
    int sourceHeight, int colorDepth, OPVP_ImageFormat imageFormat,
    OPVP_Rectangle destinationSize, int count, void *imagedata)
{
    if (procs->DrawImage == 0) {
      int result;

      if ((result = StartDrawImage(printerContext,sourceWidth,
	sourceHeight,colorDepth,imageFormat,destinationSize)) < 0) {
	return result;
      }
      if ((result = TransferDrawImage(printerContext,count,
	imagedata)) < 0) {
	return result;
      }
      return EndDrawImage(printerContext);
    }
    return procs->DrawImage(printerContext,sourceWidth, sourceHeight,
      colorDepth, imageFormat, destinationSize,count,imagedata);
}

int OPVPWrapper::StartDrawImage(int printerContext, int sourceWidth,
    int sourceHeight, int colorDepth, OPVP_ImageFormat imageFormat,
    OPVP_Rectangle destinationSize)
{
    if (procs->StartDrawImage == 0) return -1;
    return procs->StartDrawImage(printerContext,sourceWidth,
      sourceHeight,colorDepth,imageFormat,destinationSize);
}

int OPVPWrapper::TransferDrawImage(int printerContext, int count,
    void *imagedata)
{
    if (procs->TransferDrawImage == 0) return -1;
    return procs->TransferDrawImage(printerContext,count,imagedata);
}

int OPVPWrapper::EndDrawImage(int printerContext)
{
    if (procs->EndDrawImage == 0) return -1;
    return procs->EndDrawImage(printerContext);
}

int OPVPWrapper::StartScanline(int printerContext, int yposition)
{
    if (procs->StartScanline == 0) return -1;
    return procs->StartScanline(printerContext,yposition);
}

int OPVPWrapper::Scanline(int printerContext, int nscanpairs, int *scanpairs)
{
    if (procs->Scanline == 0) return -1;
    return procs->Scanline(printerContext,nscanpairs,scanpairs);
}

int OPVPWrapper::EndScanline(int printerContext)
{
    if (procs->EndScanline == 0) return -1;
    return procs->EndScanline(printerContext);
}

int OPVPWrapper::StartRaster(int printerContext, int rasterWidth)
{
    if (procs->StartRaster == 0) return -1;
    return procs->StartRaster(printerContext,rasterWidth);
}

int OPVPWrapper::TransferRasterData(int printerContext, int count,
    unsigned char *data)
{
    if (procs->TransferRasterData == 0) return -1;
    return procs->TransferRasterData(printerContext,count,
      data);
}

int OPVPWrapper::SkipRaster(int printerContext, int count)
{
    if (procs->SkipRaster == 0) return -1;
    return procs->SkipRaster(printerContext,count);
}

int OPVPWrapper::EndRaster(int printerContext)
{
    if (procs->EndRaster == 0) return -1;
    return procs->EndRaster(printerContext);
}

int OPVPWrapper::StartStream(int printerContext)
{
    if (procs->StartStream == 0) return -1;
    return procs->StartStream(printerContext);
}

int OPVPWrapper::TransferStreamData(int printerContext, int count, void *data)
{
    if (procs->TransferStreamData == 0) return -1;
    return procs->TransferStreamData(printerContext,count,data);
}

int OPVPWrapper::EndStream(int printerContext)
{
    if (procs->EndStream == 0) return -1;
    return procs->EndStream(printerContext);
}

#if (_PDAPI_VERSION_MAJOR_ > 0 || _PDAPI_VERSION_MINOR_ >= 2)
int OPVPWrapper::QueryDeviceCapability(int printerContext, int queryflag,
   int buflen, char *infoBuf)
{
    if (procs->QueryDeviceCapability == 0) return -1;
    return procs->QueryDeviceCapability(printerContext,queryflag,
      buflen,infoBuf);
}

int OPVPWrapper::QueryDeviceInfo(int printerContext, int queryflag,
   int buflen, char *infoBuf)
{
    if (procs->QueryDeviceInfo == 0) return -1;
    return procs->QueryDeviceInfo(printerContext,queryflag,
      buflen,infoBuf);
}

int OPVPWrapper::ResetClipPath(int printerContext)
{
    if (procs->ResetClipPath == 0) return -1;
    return procs->ResetClipPath(printerContext);
}

#endif

