//========================================================================
//
// SplashFTFontFile.h
//
//========================================================================

#ifndef SPLASHFTFONTFILE_H
#define SPLASHFTFONTFILE_H

#include <aconf.h>

#if HAVE_FREETYPE_FREETYPE_H || HAVE_FREETYPE_H

#ifdef USE_GCC_PRAGMAS
#pragma interface
#endif

#include <ft2build.h>
#include FT_FREETYPE_H
#ifdef HAVE_FT_OTLAYOUT
#include FT_LAYOUT_H
#include FT_OTLAYOUT_H
#endif
#include "SplashFontFile.h"

class SplashFontFileID;
class SplashFTFontEngine;

//------------------------------------------------------------------------
// SplashFTFontFile
//------------------------------------------------------------------------

class SplashFTFontFile: public SplashFontFile {
public:

  static SplashFontFile *loadType1Font(SplashFTFontEngine *engineA,
				       SplashFontFileID *idA, char *fileNameA,
				       GBool deleteFileA, char **encA);
  static SplashFontFile *loadCIDFont(SplashFTFontEngine *engineA,
				     SplashFontFileID *idA, char *fileNameA,
				     GBool deleteFileA,
				     Gushort *codeToCIDA, int codeToGIDLenA);
  static SplashFontFile *loadTrueTypeFont(SplashFTFontEngine *engineA,
					  SplashFontFileID *idA,
					  char *fileNameA,
					  GBool deleteFileA,
					  Gushort *codeToGIDA,
#ifdef HAVE_FT_OTLAYOUT
					  int codeToGIDLenA,
					  int wModeA = 0,
					  FT_ULong scriptTag = 0);
#else
					  int codeToGIDLenA);
#endif

  virtual ~SplashFTFontFile();

  // Create a new SplashFTFont, i.e., a scaled instance of this font
  // file.
  virtual SplashFont *makeFont(SplashCoord *mat);

private:

  SplashFTFontFile(SplashFTFontEngine *engineA,
		   SplashFontFileID *idA,
		   char *fileNameA, GBool deleteFileA,
		   FT_Face faceA, GBool modeUnicodeA,
#ifdef HAVE_FT_OTLAYOUT
		   Gushort *codeToGIDA, int codeToGIDLenA,
		   FTL_Glyphs_Array gaInA = 0,
		   FTL_Glyphs_Array gaOutA = 0,
		   int wModeA = 0);
#else
		   Gushort *codeToGIDA, int codeToGIDLenA);
#endif

  SplashFTFontEngine *engine;
  FT_Face face;
  Gushort *codeToGID;
  int codeToGIDLen;
  GBool modeUnicode;

  friend class SplashFTFont;
#ifdef HAVE_FT_OTLAYOUT
  FTL_Glyphs_Array gaIn;
  FTL_Glyphs_Array gaOut;
  int wMode;
#endif
};

#endif // HAVE_FREETYPE_FREETYPE_H || HAVE_FREETYPE_H

#endif
